modules/meeting/config/routes.rb
#-- copyright
# Nepenthes is a free and open project management software.
# Copyright (C) 2024 The Nirvati developers
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# Nepenthes is a fork of OpenProject. The copyright follows:
#
# Copyright (C) 2012-2024 the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

Rails.application.routes.draw do
  resources :projects, only: %i[] do
    resources :meetings, only: %i[index new create show]
  end

  resources :work_packages, only: %i[] do
    resources :meetings, only: %i[] do
      collection do
        resources :tab, only: %i[index], controller: 'work_package_meetings_tab', as: 'meetings_tab' do
          get :count, on: :collection
        end
      end
    end
    resources :meeting_agenda_items, only: %i[] do
      collection do
        get :dialog, controller: 'work_package_meetings_tab', action: :add_work_package_to_meeting_dialog
        post :create, controller: 'work_package_meetings_tab', action: :add_work_package_to_meeting
      end
    end
  end

  resources :meetings do
    member do
      get :cancel_edit
      get :download_ics
      put :update_title
      put :update_details
      get :participants_dialog
      put :update_participants
      put :change_state
      post :notify
      get :history
    end
    resources :agenda_items, controller: 'meeting_agenda_items' do
      collection do
        get :new, action: :new, as: :new
        get :cancel_new
        # get :author_autocomplete_index
      end
      member do
        get :cancel_edit
        put :drop
        put :move
      end
    end

    resource :agenda, controller: 'meeting_agendas', only: [:update] do
      member do
        get :history
        get :diff
        put :close
        put :open
        post :preview
      end

      resources :versions, only: [:show],
                           controller: 'meeting_agendas'
    end

    resource :contents, controller: 'meeting_contents', only: %i[show update] do
      member do
        get :history
        get :diff
      end
    end

    resource :minutes, controller: 'meeting_minutes', only: [:update] do
      member do
        get :history
        get :diff
        post :preview
      end

      resources :versions, only: [:show],
                           controller: 'meeting_minutes'
    end

    member do
      get :copy
      match '/:tab' => 'meetings#show', :constraints => { tab: /(agenda|minutes)/ },
            :via => :get,
            :as => 'tab'
    end
  end
end

modules/meeting/app/controllers/concerns/meetings/agenda_component_streams.rb
#-- copyright
# Nepenthes is a free and open project management software.
# Copyright (C) 2024 The Nirvati developers
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# Nepenthes is a fork of OpenProject. The copyright follows:
#
# Copyright (C) 2012-2024 the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module Meetings
  module AgendaComponentStreams
    extend ActiveSupport::Concern

    included do
      def update_header_component_via_turbo_stream(meeting: @meeting, state: :show)
        update_via_turbo_stream(
          component: Meetings::HeaderComponent.new(
            meeting:,
            state:
          )
        )
      end

      def update_sidebar_component_via_turbo_stream(meeting: @meeting)
        update_via_turbo_stream(
          component: Meetings::SidebarComponent.new(
            meeting:
          )
        )
      end

      def update_sidebar_details_component_via_turbo_stream(meeting: @meeting)
        update_via_turbo_stream(
          component: Meetings::Sidebar::DetailsComponent.new(
            meeting:
          )
        )
      end

      def update_sidebar_state_component_via_turbo_stream(meeting: @meeting)
        update_via_turbo_stream(
          component: Meetings::Sidebar::StateComponent.new(
            meeting:
          )
        )
      end

      def update_sidebar_details_form_component_via_turbo_stream(meeting: @meeting, status: :bad_request)
        update_via_turbo_stream(
          component: Meetings::Sidebar::DetailsFormComponent.new(
            meeting:
          ),
          status:
        )
      end

      def update_sidebar_participants_component_via_turbo_stream(meeting: @meeting)
        update_via_turbo_stream(
          component: Meetings::Sidebar::ParticipantsComponent.new(
            meeting:
          )
        )
      end

      def update_sidebar_participants_form_component_via_turbo_stream(meeting: @meeting)
        update_via_turbo_stream(
          component: Meetings::Sidebar::ParticipantsFormComponent.new(
            meeting:
          ),
          status: :bad_request
        )
      end

      def update_show_items_via_turbo_stream(meeting: @meeting)
        agenda_items = meeting.agenda_items.with_includes_to_render
        first_and_last = [agenda_items.first, agenda_items.last]

        agenda_items.each do |meeting_agenda_item|
          update_via_turbo_stream(
            component: MeetingAgendaItems::ItemComponent::ShowComponent.new(meeting_agenda_item:, first_and_last:)
          )
        end
      end

      def update_new_component_via_turbo_stream(hidden: false, meeting_agenda_item: nil, meeting: @meeting, type: :simple)
        update_via_turbo_stream(
          component: MeetingAgendaItems::NewComponent.new(
            hidden:,
            meeting:,
            meeting_agenda_item:,
            type:
          )
        )
      end

      def update_new_button_via_turbo_stream(disabled: false, meeting_agenda_item: nil, meeting: @meeting)
        update_via_turbo_stream(
          component: MeetingAgendaItems::NewButtonComponent.new(
            disabled:,
            meeting:,
            meeting_agenda_item:
          )
        )
      end

      def update_list_via_turbo_stream(meeting: @meeting, form_hidden: true, form_type: :simple)
        # replace needs to be called in order to mount the drag and drop handlers again
        # update would not do that and drag and drop would stop working after the first update
        replace_via_turbo_stream(
          component: MeetingAgendaItems::ListComponent.new(
            meeting:,
            form_hidden:,
            form_type:
          )
        )
        # as the list is updated without displaying the form, the new button needs to be enabled again
        # the new button might be in a disabled state
        update_new_button_via_turbo_stream(disabled: false) if form_hidden == true
      end

      def update_item_via_turbo_stream(state: :show, meeting_agenda_item: @meeting_agenda_item, display_notes_input: nil)
        replace_via_turbo_stream(
          component: MeetingAgendaItems::ItemComponent.new(
            state:,
            meeting_agenda_item:,
            display_notes_input:
          )
        )
        update_show_items_via_turbo_stream
      end

      def add_item_via_turbo_stream(meeting_agenda_item: @meeting_agenda_item, clear_slate: false)
        if clear_slate
          update_list_via_turbo_stream(form_hidden: false, form_type: @agenda_item_type)
        else
          add_before_via_turbo_stream(
            component: MeetingAgendaItems::ItemComponent.new(
              state: :show,
              meeting_agenda_item:
            ),
            target_component: MeetingAgendaItems::ListComponent.new(meeting: @meeting)
          )
          update_new_component_via_turbo_stream(hidden: false, type: @agenda_item_type)
          update_show_items_via_turbo_stream
        end
      end

      def remove_item_via_turbo_stream(meeting_agenda_item: @meeting_agenda_item, clear_slate: false)
        if clear_slate
          update_list_via_turbo_stream
        else
          update_show_items_via_turbo_stream
          remove_via_turbo_stream(
            component: MeetingAgendaItems::ItemComponent.new(
              state: :show,
              meeting_agenda_item:,
              display_notes_input: nil
            )
          )
        end
      end

      def move_item_via_turbo_stream(meeting_agenda_item: @meeting_agenda_item)
        # Note: The `remove_component` and the `component` are pointing to the same
        # component, but we still need to instantiate them separately, otherwise re-adding
        # of the item will render and empty component.
        remove_component = MeetingAgendaItems::ItemComponent.new(state: :show, meeting_agenda_item:)
        remove_via_turbo_stream(component: remove_component)

        component = MeetingAgendaItems::ItemComponent.new(state: :show, meeting_agenda_item:)
        target_component =
          if @meeting_agenda_item.lower_item
            MeetingAgendaItems::ItemComponent.new(
              state: :show,
              meeting_agenda_item: @meeting_agenda_item.lower_item
            )
          else
            MeetingAgendaItems::ListComponent.new(meeting: @meeting)
          end
        add_before_via_turbo_stream(component:, target_component:)
        update_show_items_via_turbo_stream
      end

      def render_base_error_in_flash_message_via_turbo_stream(errors)
        if errors[:base].present?
          render_error_flash_message_via_turbo_stream(message: errors[:base].to_sentence)
        end
      end

      def update_all_via_turbo_stream
        update_header_component_via_turbo_stream
        update_sidebar_component_via_turbo_stream
        update_new_button_via_turbo_stream
        update_list_via_turbo_stream
      end
    end
  end
end

modules/meeting/app/helpers/meetings_helper.rb
#-- copyright
# Nepenthes is a free and open project management software.
# Copyright (C) 2024 The Nirvati developers
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# Nepenthes is a fork of OpenProject. The copyright follows:
#
# Copyright (C) 2012-2024 the OpenProject GmbH
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 3.
#
# OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
# Copyright (C) 2006-2013 Jean-Philippe Lang
# Copyright (C) 2010-2013 the ChiliProject Team
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# See COPYRIGHT and LICENSE files for more details.
#++

module MeetingsHelper
  def top_level_sidebar_menu_items
    [
      menu_upcoming_meetings_item,
      menu_past_meetings_item
    ]
  end

  def involvement_sidebar_menu_items
    [
      menu_upcoming_invitations_item,
      menu_past_invitations_item,
      menu_attendee_item,
      menu_creator_item
    ]
  end

  def menu_upcoming_meetings_item
    path = project_or_global_meetings_path

    menu_link_element path, t(:label_upcoming_meetings)
  end

  def menu_past_meetings_item
    path = project_or_global_meetings_path(
      filters: [{ time: { operator: "=", values: ["past"] } }],
      sort: "start_time:desc"
    )

    menu_link_element path, t(:label_past_meetings)
  end

  def menu_upcoming_invitations_item
    path = project_or_global_meetings_path(
      filters: [
        { time: { operator: "=", values: ["future"] } },
        { invited_user_id: { operator: "=", values: [User.current.id.to_s] } }
      ],
      sort: "start_time"
    )

    menu_link_element path, t(:label_upcoming_invitations)
  end

  def menu_past_invitations_item
    path = project_or_global_meetings_path(
      filters: [
        { time: { operator: "=", values: ["past"] } },
        { invited_user_id: { operator: "=", values: [User.current.id.to_s] } }
      ],
      sort: "start_time:desc"
    )

    menu_link_element path, t(:label_past_invitations)
  end

  def menu_attendee_item
    path = project_or_global_meetings_path(
      filters: [{ attended_user_id: { operator: "=", values: [User.current.id.to_s] } }]
    )

    menu_link_element path, t(:label_attendee)
  end

  def menu_creator_item
    path = project_or_global_meetings_path(
      filters: [{ author_id: { operator: "=", values: [User.current.id.to_s] } }]
    )

    menu_link_element path, t(:label_author)
  end

  def project_or_global_meetings_path(filters: nil, sort: nil)
    return polymorphic_path([@project, :meetings]) if filters.blank? && sort.blank?

    query_params = {}.tap do |query|
      query[:filters] = filters.to_json if filters.present?
      query[:sort] = sort if sort.present?
    end

    polymorphic_path([@project, :meetings], query_params)
  end

  def menu_link_element(path, label)
    link_to path, class: menu_item_css_class(path), title: label do
      content_tag(:span, class: "op-sidemenu--item-title") do
        label
      end
    end
  end

  def menu_item_css_class(path)
    "op-sidemenu--item-action#{menu_item_selected(path) ? ' selected' : ''}"
  end

  def menu_item_selected(menu_item_path)
    menu_item_path == request.fullpath
  end

  def format_participant_list(participants)
    if participants.any?
      user_links = participants
        .sort
        .reject { |p| p.user.nil? }
        .map { |p| link_to_user p.user }

      safe_join(user_links, "; ")
    else
      t("placeholders.default")
    end
  end

  def render_meeting_journal(model, journal, options = {})
    return "" if journal.initial?

    journal_content = render_journal_details(journal, :label_updated_time_by, model, options)
    content_tag "div", journal_content, id: "change-#{journal.id}", class: "journal"
  end

  # This renders a journal entry with a header and details
  def render_journal_details(journal, header_label = :label_updated_time_by, _model = nil, options = {})
    header = <<-HTML
      <div class="profile-wrap">
        #{avatar(journal.user)}
      </div>
      <h4>
        <div class="journal-link" style="float:right;">#{link_to "##{journal.anchor}", anchor: "note-#{journal.anchor}"}</div>
        #{authoring journal.created_at, journal.user, label: header_label}
        #{content_tag('a', '', name: "note-#{journal.anchor}")}
      </h4>
    HTML

    if journal.details.any?
      details = content_tag "ul", class: "details journal-attributes" do
        journal.details.filter_map do |detail|
          if d = journal.render_detail(detail, cache: options[:cache])
            content_tag("li", d.html_safe)
          end
        end.join(" ").html_safe
      end
    end

    content_tag("div", "#{header}#{details}".html_safe, id: "change-#{journal.id}", class: "journal")
  end

  def global_meeting_create_context?
    global_new_meeting_action? || global_create_meeting_action?
  end

  def global_new_meeting_action?
    request.path == new_meeting_path
  end

  def global_create_meeting_action?
    request.path == meetings_path && @project.nil?
  end
end

modules/meeting/app/views/meetings/_form.html.erb
<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<%= error_messages_for 'meeting' %>

<section class="form--section">

  <div class="form--field -required">
    <%= f.text_field :title, :required => true, :size => 60, container_class: '-wide' %>
  </div>

  <% copy_from = local_assigns[:copy_from] %>
  <% if copy_from.present? %>
    <%= f.hidden_field :type, value: copy_from.type %>
    <%= hidden_field_tag "copied_from_meeting_id", copy_from.id %>
    <div class="form--field">
      <%= styled_label_tag 'copy_agenda', t('meeting.copy.agenda') %>
      <div class="form--field-container">
        <%= styled_check_box_tag 'copy_agenda',
                                 1,
                                 true,
                                 no_label: true,
                                 class: 'radio-button' %>
      </div>
      <div class="form--field-instructions">
        <%= t('meeting.copy.agenda_text') %>
      </div>
    </div>
    <div class="form--field">
      <%= styled_label_tag 'copy_attachments', t('meeting.copy.attachments') %>
      <div class="form--field-container">
        <%= styled_check_box_tag 'copy_attachments',
                                 1,
                                 false,
                                 no_label: true,
                                 class: 'radio-button' %>
      </div>
      <div class="form--field-instructions">
        <%= t('meeting.copy.attachments_text') %>
      </div>
    </div>
  <% elsif @meeting.new_record? %>
    <div class="form--field -required -align-start">
      <label class="form--label" for="meeting_type"><%= Meeting.human_attribute_name(:type) %></label>
      <div class="form--field-container">
        <div class="op-tile-block">
          <label class="op-tile-block--tile form--radio-button-container -wide"
                 for="meeting_type_dynamic"
                 data-test-selector="op-tile-block">
            <div class="op-tile-block--content">
              <%= styled_radio_button_tag 'meeting[type]',
                                          'StructuredMeeting',
                                          true,
                                          no_label: true,
                                          class: 'radio-button' %>
              <div>
              <span data-test-selector="op-tile-block-title" class="op-tile-block--title">
                <%= t('meeting.types.structured') %>
              </span>
                <p class="op-tile-block--description">
                  <%= t('meeting.types.structured_text') %>
                  <% if local_assigns[:copy] %>
                    <br/>
                    <strong><%= t('meeting.types.structured_text_copy') %></strong>
                  <% end %>
                </p>
              </div>
            </div>
          </label>
          <label class="op-tile-block--tile form--radio-button-container -wide"
                 for="meeting_type_classic"
                 data-test-selector="op-tile-block">
            <div class="op-tile-block--content">
              <%= styled_radio_button_tag 'meeting[type]',
                                          'Meeting',
                                          false,
                                          no_label: true,
                                          class: 'radio-button' %>
              <div>
              <span data-test-selector="op-tile-block-title" class="op-tile-block--title">
                <%= t('meeting.types.classic') %>
              </span>
                <p class="op-tile-block--description">
                  <%= t('meeting.types.classic_text') %>
                </p>
              </div>
            </div>
          </label>
        </div>
      </div>
    </div>
  <% end %>

  <% if global_meeting_create_context? %>
    <div class="form--field -required">
      <label class="form--label" for="project_id"><%= Meeting.human_attribute_name(:project) %>:</label>
      <div class="form--field-container">
        <%= angular_component_tag 'opce-project-autocompleter',
                                  inputs: {
                                    filters: [{ name: 'user_action', operator: '=', values: ['meetings/create'] }],
                                    inputName: 'project_id',
                                    inputValue: @project&.id,
                                    appendTo: 'body',
                                    hiddenFieldAction: 'change->refresh-on-form-changes#triggerTurboStream',
                                  },
                                  id: 'project_id',
                                  class: 'form--select-container -wide remote-field--input',
                                  data: {
                                    'test-selector': 'project_id'
                                  }
        %>
      </div>
    </div>
  <% end %>

  <div class="form--field">
    <%= f.text_field :location, :size => 60, container_class: '-wide' %>
  </div>

  <div class="form--field -required">
    <label for="meeting_start_date" class="form--label"><%= Meeting.human_attribute_name(:start_date) %>
      <span class="hidden-for-sighted">
        <%= t(:label_start_date) %><%= t(:text_hint_date_format) %>
      </span>
    </label>

    <div class="form--field-container -visible-overflow">
      <%= f.date_picker :start_date,
                        id: 'meeting-form-start-date',
                        required: true,
                        no_label: true
      %>
      <label for="meeting-form-start-time" class="hidden-for-sighted">
        <%= Meeting.human_attribute_name(:start_time) %>
        <label lang="en">
          <%= t(:label_time_zone) %>
          <%= Time.zone.to_s %>
        </label>
      </label>
      <%= f.text_field :start_time_hour,
                       id: 'meeting-form-start-time',
                       required: true,
                       type: 'time',
                       no_label: true,
                       step: 5.minutes,
                       suffix: Time.zone.to_s,
                       container_class: '-xslim' %>
    </div>
  </div>

  <div class="form--field -required">
    <label for="meeting-form-duration" class="form--label"><%= Meeting.human_attribute_name(:duration) %></label>
    <div class="form--field-container">
      <%= f.number_field :duration,
                         id: 'meeting-form-duration',
                         required: true,
                         size: 5,
                         no_label: true,
                         min: 0.00,
                         step: 0.25,
                         max: 168,
                         suffix: t(:text_in_hours),
                         container_class: '-xslim' %>
    </div>
  </div>

  <%= render partial: 'meetings/participants_section' %>
</section>

modules/meeting/app/views/meetings/participants_dialog.turbo_stream.erb
<%=
  turbo_stream.dialog do
    render(Meetings::Sidebar::ParticipantsDialog.new(meeting: @meeting))
  end
%>

modules/meeting/app/views/meetings/show.html.erb
<%#-- copyright
Nepenthes is a free and open project management software.
Copyright (C) 2024 The Nirvati developers

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

Nepenthes is a fork of OpenProject. The copyright follows:

Copyright (C) 2012-2024 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>

<%= toolbar title: t(:label_meeting),
            link_to: link_to(@meeting),
            html: { class: 'meeting--main-toolbar -with-dropdown' } do %>
  <% unless User.current.anonymous? %>
    <li class="toolbar-item hidden-for-tablet">
      <div class="button">
        <%= watcher_link @meeting, User.current %>
      </div>
    </li>
  <% end %>
  <% if authorize_for(:meetings, :edit) %>
    <li class="toolbar-item">
      <%= link_to({ :controller => '/meetings', :action => 'edit', :id => @meeting }, class: 'button', :accesskey => accesskey(:edit)) do %>
        <%= op_icon('button--icon icon-edit') %>
        <span class="button--text"><%= t(:button_edit) %></span>
      <% end %>
    </li>
  <% end %>

  <li class="toolbar-item drop-down">
    <a
      href="#"
      aria-haspopup="true"
      title="<%= t(:label_more) %>"
      class="button"
      data-test-selector="meetings-more-dropdown-menu"
    >
      <%= op_icon('button--icon icon-show-more') %>
    </a>
    <ul style="display:none;" class="menu-drop-down-container">
      <% if authorize_for(:meetings, :notify) %>
        <li>
          <%= link_to t('meeting.label_mail_all_participants'),
                      notify_meeting_path(@meeting),
                      class: 'icon-context icon-mail1',
                      method: :post %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :icalendar) %>
        <li>
          <%= link_to t(:label_icalendar_download),
                      download_ics_meeting_path(@meeting),
                      class: 'icon-context icon-calendar2' %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :copy) %>
        <li>
          <%= link_to(t(:button_copy),
                      copy_meeting_path(@meeting),
                      class: 'icon-context icon-copy') %>
        </li>
      <% end %>
      <% if authorize_for(:meetings, :destroy) %>
        <li>
          <%= link_to(t(:button_delete),
                      meeting_path(@meeting),
                      class: 'icon-context icon-delete',
                      method: :delete,
                      data: { confirm: t(:text_are_you_sure) }) %>
        </li>
      <% end %>
    </ul>
  </li>
<% end %>

<div class="meeting details box">
  <div class="grid-block wrap">
    <div class="grid-content small-12 block--author">
      <%= avatar(@meeting.author) %>
      <p class="author"><%= authoring @meeting.created_at, @meeting.author %></p>
    </div>
    <div class="grid-content small-6">
      <p>
        <strong><%= Meeting.human_attribute_name(:start_time) %></strong>: <%= format_date @meeting.start_time %> <%= format_time @meeting.start_time, false %>
        - <%= format_time @meeting.end_time, false %> <%= Time.zone %></p>
    </div>
    <div class="grid-content small-6">
      <p>
        <strong><%= Meeting.human_attribute_name(:location) %></strong>: <%= auto_link(h(@meeting.location), link: :all, html: { target: '_blank' }) %>
      </p>
    </div>
    <div class="grid-content small-12">
      <p>
        <strong><%= Meeting.human_attribute_name(:participants_invited) %></strong>: <%= format_participant_list @meeting.participants.invited %>
      </p>
    </div>
    <div class="grid-content small-12">
      <p>
        <strong><%= Meeting.human_attribute_name(:participants_attended) %></strong>: <%= format_participant_list @meeting.participants.attended %>
      </p>
    </div>
  </div>
</div>

<%= render_tabs [{ :name => 'agenda', :action => :create_meeting_agendas, :partial => 'meeting_contents/show', :path => meeting_agenda_path(@meeting), :label => :label_meeting_agenda, :content => @meeting.agenda || @meeting.build_agenda, :content_type => "meeting_agenda" },
                 { :name => 'minutes', :action => :create_meeting_minutes, :partial => 'meeting_contents/show', :path => meeting_minutes_path(@meeting), :label => :label_meeting_minutes, :content => @meeting.minutes || @meeting.build_minutes, :content_type => "meeting_minutes" }] %>

<% if @meeting.journals.changing.present? %>
  <div id="history">
    <h3><%= t(:label_history) %></h3>
    <% @meeting.journals.each do |journal| %>
      <%= render_meeting_journal @meeting, journal %>
    <% end %>
  </div>
<% end %>